CompletionWindow = class(Turbine.UI.Lotro.Window)
function CompletionWindow:Constructor(handler)
    Turbine.UI.Lotro.Window.Constructor(self)

    self.width = 1000
    self.height = 700
    self.handler = handler
    self:SetSize(self.width, self.height)
    self:SetText("Challenge Complete")
    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - self.width / 2, Turbine.UI.Display.GetHeight() / 2 - self.height / 2)
    self:SetVisible(true)

    self.completionLabel = Turbine.UI.Label()
    self.completionLabel:SetParent(self)
    self.completionLabel:SetSize(self:GetWidth(), 50)
    self.completionLabel:SetTop(50)
    self.completionLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.completionLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.completionLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.completionLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.completionLabel:SetText("Hardcore Challenge Level 50 Complete!")
    self.partyOffset = 0
    self.statWindow = StatControl(self.handler:GetCharacterData(), self, self.handler.startTime)
    self.statWindow:SetPosition(self:GetWidth() / 2 - self.statWindow:GetWidth() / 2 + 70, 80)

    if  PrimeUtils.Utils.Tablelength(self.handler.characterData.Party) > 0 then
        self.partyLabel = Turbine.UI.Label()
        self.partyLabel:SetParent(self)
        self.partyLabel:SetSize(self:GetWidth(), 50)
        self.partyLabel:SetTop(300)
        self.partyLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        self.partyLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        self.partyLabel:SetOutlineColor(Turbine.UI.Color.Black)
        self.partyLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold24)
        self.partyLabel:SetText("Fellowship")

        self.fellowshipListbox = Turbine.UI.ListBox()
        self.fellowshipListbox:SetParent(self)
        self.fellowshipListbox:SetSize(260 * 3, 100 )
        self.fellowshipListbox:SetPosition(self:GetWidth() / 2 -  self.fellowshipListbox:GetWidth() / 2, 350)
        self.fellowshipListbox:SetOrientation(Turbine.UI.Orientation.Horizontal)
        self.fellowshipListbox:SetMaxColumns(6)

        for key, value in pairs(self.handler.characterData.Party) do
            local fellowshipLabel = Turbine.UI.Label()
            fellowshipLabel:SetSize(120, 20)
            fellowshipLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
            fellowshipLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
            fellowshipLabel:SetOutlineColor(Turbine.UI.Color.Black)
            fellowshipLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro16)
            fellowshipLabel:SetText(key)
        
            self.fellowshipListbox:AddItem(fellowshipLabel)
        end

        self.fellowshipListbox:SetSize(math.min(6, self.fellowshipListbox:GetItemCount()) * 120, math.ceil(self.fellowshipListbox:GetItemCount() / 6) * 20)
        self.fellowshipListbox:SetPosition(self:GetWidth() / 2 -  self.fellowshipListbox:GetWidth() / 2, 350)

        self.partyOffset = 100
    end

    self.achievementsLabel = Turbine.UI.Label()
    self.achievementsLabel:SetParent(self)
    self.achievementsLabel:SetSize(self:GetWidth(), 50)
    self.achievementsLabel:SetTop(300 + self.partyOffset)
    self.achievementsLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.achievementsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.achievementsLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.achievementsLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold36)
    self.achievementsLabel:SetText("Completed Achievements")

    self.completionListbox = Turbine.UI.ListBox()
    self.completionListbox:SetParent(self)
    self.completionListbox:SetSize(260 * 3, 100 )
    self.completionListbox:SetPosition(self:GetWidth() / 2 -  self.completionListbox:GetWidth() / 2, 350 + self.partyOffset)
    self.completionListbox:SetOrientation(Turbine.UI.Orientation.Horizontal)
    self.completionListbox:SetMaxColumns(8)

    local ach = self.handler:GetAchievementData()
    for key, value in pairs(self.handler:GetCharacterData().Achievements_Done) do
        local achievementInfo = ach[key]

        local AchievementControl = Turbine.UI.Control()
        AchievementControl:SetSize(100, 100)
        AchievementControl:SetBackColor(Turbine.UI.Color.DarkGray)

        AchievementControl.InnerBackground = Turbine.UI.Control()
        AchievementControl.InnerBackground:SetParent(AchievementControl)
        AchievementControl.InnerBackground:SetPosition(10, 10)
        AchievementControl.InnerBackground:SetSize(80, 80)
        AchievementControl.InnerBackground:SetBackColor(Turbine.UI.Color.Black)

        AchievementControl.Label = Turbine.UI.Label()
        AchievementControl.Label:SetSize(100, 20)
        AchievementControl.Label:SetParent(AchievementControl)
        AchievementControl.Label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
        AchievementControl.Label:SetFontStyle(Turbine.UI.FontStyle.Outline)
        AchievementControl.Label:SetOutlineColor(Turbine.UI.Color.Black)
        AchievementControl.Label:SetFont(Turbine.UI.Lotro.Font.TrajanPro13)
        AchievementControl.Label:SetText(achievementInfo.Title)

        AchievementControl.Icon = Turbine.UI.Control()
        AchievementControl.Icon:SetParent(AchievementControl)
        AchievementControl.Icon:SetPosition(30, 30)
        AchievementControl.Icon:SetBackground(achievementInfo.Icon)
        AchievementControl.Icon:SetStretchMode(2)
        AchievementControl.Icon:SetStretchMode(1)
        AchievementControl.Icon:SetSize(40, 40)

        local difficulty = achievementInfo.Difficulty or self.handler.data.Difficulty
        local startPosition = 50 - difficulty * (100 / 2 / 9)
        for i = 1, difficulty do
            local star = Turbine.UI.Control()
            star:SetParent(AchievementControl)
            star:SetPosition((i - 1) * 10 + startPosition, 80)
            star:SetBackground(0x410E82A1)
            star:SetStretchMode(2)
            --ChatOutput(star:GetWidth())
            --ChatOutput(star:GetHeight())
            star:SetStretchMode(1)
            star:SetSize(20, 20)
        end

        self.completionListbox:AddItem(AchievementControl)
    end

    self.completionListbox:SetSize(math.min(8, self.completionListbox:GetItemCount()) * 100, math.ceil(self.completionListbox:GetItemCount() / 8) * 100)
    self.completionListbox:SetPosition(self:GetWidth() / 2 -  self.completionListbox:GetWidth() / 2, 350 + self.partyOffset)
end

--0x410E82A1